#!/usr/bin/suidperl
# This program must be setuid root to work correctly

sub scriptDir {
  my $scr = $0;
  if($scr =~ /(.*)\/.*/) {
    return $1;
  } else {
    return ".";
  }
}

use CGI qw/:standard/;
use CGI::Carp 'fatalsToBrowser';
use strict;
use lib scriptDir();
require "changePass.pl";

my $q = new CGI;

my $userName = $q->param('UserName');
my $oldPass = $q->param('OldPass');
my $newPass1 = $q->param('NewPass1');
my $newPass2 = $q->param('NewPass2');

sub printForm {
  print <<EOF ;
<form action="$ENV{REQUEST_URI}" method="post">
 <table border bgcolor="#c0c0ff">
  <tr>
   <td>UserName:<td><input type="text" name="UserName" value="$userName">
  <tr>
   <td>Old Password:<td><input type="password" name="OldPass" value="$oldPass">
  <tr>
   <td>New Password:<td><input type="password" name="NewPass1" value="$newPass1">
  <tr>
   <td>New Password (confirm):<td><input type="password" name="NewPass2" value="$newPass2">
  <tr>
   <td colspan=2 align="center"><input type="Submit">
</table>
</form>

EOF
}


if(!defined $userName && !defined $oldPass &&
   !defined $newPass1 && !defined $newPass2) {
  print header, start_html('Online change password form');
  printForm;
  print end_html();
  exit 0;
}

eval {
  if(!defined $userName){
    die "User name not defined\n";
  }

  if(!defined $oldPass) {
    die "Missing old pass\n";
  }

  if(!defined $newPass1) {
    die "Missing new pass\n";
  }

  if(!defined $newPass2) {
    die "Missing new pass confirmation\n";
  }

  if($newPass1 ne $newPass2) {
    die "New passwords differ\n";
  }

  changePass("webpass", $userName, $oldPass, $newPass1);
};

if($@) {
  my $err = $@;
  print
    header,
    start_html('Error while changing password'),
    "Error while changing password: \"".escapeHTML($err)."\"";
  printForm;
  print end_html();
  exit(0);
}

print
  header,
  start_html('Your password has been changed'),
  "Your password has been successfully changed",
  end_html;
